''          XML Firewall
''      .
''  Web      "" .
''   ,   "demo",      
''        .

Option Explicit

Dim debug	               ''       "debug" 
debug = FALSE
'Test.TraceLevel = -1	   ''     ACTTrace.log 
                           ''     debug  .   
                           ''    .
Dim httpConnection	       ''     HTTP   XML Firewall
Dim SOAPRequest            ''  
Dim serverHostName	       ''  IP       XML Firewall
Dim serverPortNumber	   ''     XML Firewall  
Dim endpointRelativePath   ''    Web 
Dim SOAPActionHeader	   ''   SOAPAction,    
                           ''     HTTP .

Dim expectedAnswer	       ''      .       
                           ''     

Dim httpRequest		       ''  HTTP 
Dim httpResponse	       ''  HTTP 


''--------------------------------------------------------------------------------
''          
''     1                                                  
''--------------------------------------------------------------------------------

serverHostName    	    = 	"xmlfperf"
serverPortNumber        =   8080
endpointRelativePath 	= 	"/xmlf/runtime/echo_signed"	
SOAPActionHeader        =   "http://echo"
SOAPRequest             = 	"<?xml version="1.0" encoding="UTF-8"?><SOAP-ENV:Envelope xmlns:SOAP-ENC=http://schemas.xmlsoap.org/soap/encoding/
                              xmlns:SOAP-ENV=http://schemas.xmlsoap.org/soap/envelope/
                              xmlns:impl=http://localhost:8080/axis/EchoService.jws-impl
                              xmlns:intf=http://localhost:8080/axis/EchoService.jws
                              xmlns:wsdl=http://schemas.xmlsoap.org/wsdl/
                              xmlns:wsdlsoap=http://schemas.xmlsoap.org/wsdl/soap/
                              xmlns:xsd=http://www.w3.org/2001/XMLSchema
                              xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
                               <SOAP-ENV:Header>
                               <wsse:Security SOAP-ENV:actor="http://demo" SOAP-ENV:mustUnderstand="1"
                                xmlns:SOAP-ENV=http://schemas.xmlsoap.org/soap/envelope/
                                xmlns:wsse=http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd
                                xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd">
                                <wsse:BinarySecurityToken
								EncodingType="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-soap-message-security-1.0#Base64Binary" ValueType="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-x509-token-profile-1.0#X509v3" wsu:Id="SecurityToken-d7e4b257-6880-057b-4a29-7e485822f4f1">
								MIICZzCCAiSgAwIBAAIERXKy0zALBgcqhkjOOAQDBQAwejEfMB0GCSqGSIb3DQEJARYQc
								GVyZm9ybWFuY2VAZGVtbzELMAkGA1UEBhMCQkcxDjAMBgNVBAgTBVNvZmlhMQ0wCwYDVQ
								QHEwREZW1vMQ0wCwYDVQQKEwREZW1vMQ0wCwYDVQQLEwREZW1vMQ0wCwYDVQQDEwREZW1
								vMB4XDTA2MTIwMzExMTk0N1oXDTA3MTIwMzExMTk0N1owejEfMB0GCSqGSIb3DQEJARYQ
								cGVyZm9ybWFuY2VAZGVtbzELMAkGA1UEBhMCQkcxDjAMBgNVBAgTBVNvZmlhMQ0wCwYDV
								QQHEwREZW1vMQ0wCwYDVQQKEwREZW1vMQ0wCwYDVQQLEwREZW1vMQ0wCwYDVQQDEwREZW
								1vMIHxMIGoBgcqhkjOOAQBMIGcAkEA/KaCzo4Syrom78z3EQ5SbbB4sF7ey80etKII864
								WF64B81uRpH5t9jQTxeEu0ImbzRMqzVDZkVG9xD7nN1kuFwIVAJYu3cw2nLqOuyYO5rahJ
								tk0bjjFAkBnhHGyepz0TukaScUUfbGpqvJE8FpDTWSGkx0tFCcbnjUDC3H9c9oXkGmzLik
								1Yw4cIGI1TQ2iCmxBblC+eUykA0QAAkEAx383whuwHdZc/Mp+e3nNas/wVYqSXFFmlxfSUP
								1/iqHTfq6+RXZd85HLnISH0SxoS2pUURWcCniV4TBp+gGKczALBgcqhkjOOAQDBQADMAAwL
								QIUdI5sJSvqvWk6dK73qMShnxfffKICFQCJoWovXIYVpNf2Yp1nWqoGBCuEgA==
								</wsse:BinarySecurityToken>
								<dsig:Signature xmlns:dsig="http://www.w3.org/2000/09/xmldsig#">
								<dsig:SignedInfo>
								<dsig:CanonicalizationMethod Algorithm="http://www.w3.org/2001/10/xml-exc-  c14n#"/>
								<dsig:SignatureMethod Algorithm="http://www.w3.org/2000/09/xmldsig#dsa-sha1"/>
								<dsig:Reference URI="#Id-2d5313db-87bb-c227-7dc8-cfef5f797d0c">
								<dsig:Transforms>
								<dsig:Transform Algorithm="http://www.w3.org/2001/10/xml-exc-c14n#"/>
								</dsig:Transforms>
								<dsig:DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"/>
								<dsig:DigestValue>PcaFHlU/G4DCjrWUteuy0NPY5iU=</dsig:DigestValue>
								</dsig:Reference>
								</dsig:SignedInfo>
								<dsig:SignatureValue>dVRSipsSVxghex5ciEm9zhdeBs1xYF5twA6z++KVYFTze2TWYROjSQ==</dsig:SignatureValue>
								<dsig:KeyInfo>
								<SecurityTokenReference xmlns="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd">
								<wsse:Reference URI="#SecurityToken-d7e4b257-6880-057b-4a29-7e485822f4f1"/>
								</SecurityTokenReference>
								</dsig:KeyInfo>
								</dsig:Signature>
								</wsse:Security>
								</SOAP-ENV:Header>
									<SOAP-ENV:Body wsu:Id="Id-2d5313db-87bb-c227-7dc8-cfef5f797d0c" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd">
									<m:echo SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:m="http://localhost:8080/axis/EchoService.jws">
									<in0 xsi:type="xsd:string">demo</in0>
								</m:echo>
								</SOAP-ENV:Body>
								</SOAP-ENV:Envelope>"


expectedAnswer		=	"demo"

''--------------------------------------------------------------------------------
''                                                    
''--------------------------------------------------------------------------------

''        
Function IsStringInResponseBody(response, string)

	If InStr(response.Body, string) Then
		IsStringInResponseBody = True
	Else
		IsStringInResponseBody = False
	End if

End Function

''   HTTP ,   ,         
  ,   

Sub ReplaceHeader(request, httpHeaderName, httpHeaderNewValue)
	Call request.Headers.Remove(httpHeaderName)
	Call request.Headers.Add(httpHeaderName, httpHeaderNewValue)
End Sub


''   ACTTrace.log  ,       debug 

Sub Log(message)
	If debug Then
       	Test.Trace(message)
	End if
End Sub

''--------------------------------------------------------------------------------
''                                                     
''--------------------------------------------------------------------------------

''      HTTP 
Set httpConnection = Test.CreateConnection(serverHostName, serverPortNumber)

If (httpConnection is Nothing) Then
    Call Log("Error creating the httpConnection")                         '' 
									
Else
	Set httpRequest = Test.CreateRequest	                              ''    HTTP .		
	httpRequest.CodePage = 65001		                                  ''UTF-8 encoding
	httpRequest.EncodeBody = False		                                  ''     
	httpRequest.Verb = "POST"			                                  ''POST   				
    httpRequest.Headers.Add "SOAPAction", SOAPActionHeader	              ''  SOAPAction     
    httpRequest.Body = SOAPRequest                                        ''  SOAP   
    httpRequest.PATH = endpointRelativePath	                              ''    			
    Call ReplaceHeader(httpRequest, "Connection", "Close")                ''      
	Set httpResponse = httpConnection.Send(httpRequest)                   ''      


	If (httpResponse Is Nothing) Then                                     ''      
		Call Log("Error receiving the response")							
	Else                                                                  ''  
        If IsStringInResponseBody(httpResponse, expectedAnswer) Then      ''    
			Call Log("SUCCESS: " & httpResponse.Body)	 
		Else                                                              ''     .  , 
            Call Log("ERROR: " & httpResponse.Body)                       ''                                                            					
		End If
	End If
End If
